<?php

class DES
{
    private $iv = "0102030405060708";

    /*
     * 在采用DES加密算法,cbc模式,pkcs5Padding字符填充方式,对密文进行解密函数
     */

    function decrypt($crypt, $key)
    {
        if (function_exists('openssl_decrypt')) {
            // 尽量使用openssl解密
            $result = openssl_decrypt($crypt, "DES-CBC", $key, 0, $this->hexToStr($this->iv));
        } else if (function_exists('mcrypt_module_open')) {
            // openssl未开启的情况下，使用mcrypt_module，mcrypt_module方法PHP7.1后过期
            $crypt = base64_decode($crypt);   //对加密后的密文进行解base64编码
            $iv = $this->hexToStr($this->iv);  //$iv为加解密向量
            $td = mcrypt_module_open(MCRYPT_DES, '', 'cbc', '');
            mcrypt_generic_init($td, $key, $iv);
            $decrypted_data = mdecrypt_generic($td, $crypt);
            mcrypt_generic_deinit($td);
            mcrypt_module_close($td);
            $decrypted_data = $this->pkcs5_unpad($decrypted_data);
            $result = rtrim($decrypted_data);   //去空格
        } else {
            $result = 'PHP版本高于7.0，请开启openssl扩展';
        }
        return $result;
    }

    /*
     * 16进制转普通字符串
     */

    function hexToStr($hex)
    {
        $str = "";
        for ($i = 0; $i < strlen($hex) - 1; $i += 2)
            $str .= chr(hexdec($hex[$i] . $hex[$i + 1]));
        return $str;
    }

    /*
	 * 对解密后的已字符填充的明文进行去掉填充字符
	 */

    function pkcs5_unpad($text)
    {
        $pad = ord($text{strlen($text) - 1});
        if ($pad > strlen($text))
            return false;
        return substr($text, 0, -1 * $pad);
    }

}