<?php

header('content-type:text/html;charset=utf-8');
include_once "Encrypt.php";

/**
 * 免密登录Demo
 * 移动免密登录URL:https://api.253.com/open/flashsdk/mobile-query-m
 * 联通免密登录URL:https://api.253.com/open/flashsdk/mobile-query-u
 * 电信免密登录URL:https://api.253.com/open/flashsdk/mobile-query-t
 */

$url = ''; // 请根据运营商填入对应的URL地址，详见上面注释
$version = '2.0.6';// SDK版本号，SDK传入
$desKey = ''; // Des 解密key ，请填入自己闪验应用的appKey
$params = [
    'appId' => '', // 当前APP对应的appid,SDK传入
    'accessToken' => '', // 运营商token,SDK传入
    'telecom' => '', // 运营商，SDK传入
    'timestamp' => '', // UNIX时间戳，毫秒级，SDK传入
    'randoms' => '', // 随机数，SDK传入
    'device' => '', // 设备型号，SDK传入
    'sign' => '', // 签名，SDK传入
    'version' => $version, // SDK版本号，SDK传入
];
// CURL 模拟 post 请求
$ch = curl_init();
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
curl_setopt($ch, CURLOPT_TIMEOUT, 5);
$resultJson = curl_exec($ch);
$curlInfo = curl_getinfo($ch);

// CURL 错误码
$errNo = curl_errno($ch);
if ($errNo > 0) {
    // 通信失败处理逻辑，请自己填充

    // CURL 错误信息
    $errMsg = curl_error($ch);
    // TODO
} elseif (!empty($curlInfo) && intval($curlInfo['http_code']) != 200) {
    // http 状态码不是 200，请求失败处理逻辑
    $httpCode = $curlInfo['http_code'];
    // TODO
} else {
    // 拿到请求结果，使用返回结果逻辑
    $requestData = json_decode($resultJson, true);
    if ($requestData['code'] == 200000) {
        $chargeStatus = $requestData['chargeStatus']; // 是否收费，枚举值：1 ：收费 0：不收费
        $mobile = $requestData['data']['mobileName']; // 手机号
		$des = new Des();
		$mobile = $des->decrypt($mobile, $desKey);
		// 如des 解密失败 请检查$desKey是否正确 TODO
        $tradeNo = $requestData['data']['tradeNo']; // 流水号
        // 拿到返回数据继续处理逻辑 TODO
    } else {
        // 响应异常处理逻辑 TODO
    }
}
?>