require 'net/http'
require 'json'

class Des
  require 'openssl'
  require 'base64'
  ALG = 'DES-CBC'
  IV =["0102030405060708"].pack "H*"

  def decode(str,key)
    str = Base64.decode64(str)
    des = OpenSSL::Cipher::Cipher.new(ALG)
    des.decrypt
    des.key = key
    des.iv = IV
    des.update(str) + des.final
  end
end

#以下参数的值改为SDK实际返回的值
appId="xxxxxxxx"
randoms="86d9ac0b-48e0-4aaa-b44b-c03455a1817d"
timestamp="1560301876460"
device="device=HUAWEI"
telecom="CTCC"
version="2.1.3"
accessToken="d9e430aa2c8d449594dd064ef5053249"
sign="VjAoUc5+Em7MBD5cq5IcBelPp+c="

#appId对应的appKey，用于解密手机号
appKey="xxxxxxxx"


#请求地址
if telecom=="CUCC"
    url = 'https://api.253.com/open/flashsdk/mobile-query-u'
elsif telecom=="CTCC"
    url = 'https://api.253.com/open/flashsdk/mobile-query-t'
elsif telecom=="CMCC"
    url = 'https://api.253.com/open/flashsdk/mobile-query-m'
end

#发送post请求
uri = URI(url)
res = Net::HTTP.post_form(uri, 'appId' => appId, 'randoms' => randoms,'timestamp'=>timestamp,'device'=>device,'telecom'=>telecom,'version'=>version,'accessToken'=>accessToken,'sign'=>sign)
body=res.body
obj=JSON.parse(body)

#解析返回结果
if obj['code']=='200000'
  tradeNo=obj['data']['tradeNo']
  #解密手机号码
  mobileStr = obj['data']['mobileName']
  des = Des.new
  puts '本次交易流水号：'+tradeNo+',手机号码：'+des.decode(mobileStr,appKey)
else
  puts '返回错误信息：'+body
end

